import unittest
import HTMLTestReportCN
import time
from common.Mail import sendResultMail
from HTMLTestReportCN import TestResult
from common.resultToDing import msgSend


#case_dir = 'D:/workSpace/Python_workspace/myPython/.idea/interfaceTest_ddt/case'
#report_dir = 'D:/workSpace/Python_workspace/myPython/.idea/interfaceTest_ddt/repot'
case_dir = '/opt/apitest/apiAutoByJenkins/case'
report_dir = '/opt/apitest/apiAutoByJenkins/repot'
discover = unittest.defaultTestLoader.discover(case_dir,pattern='test*.py')
#discover = unittest.defaultTestLoader.discover(case_dir,pattern='testcase.py')
now = time.strftime('%Y%m%d%H%M%S')
fileName = '/'+now+'test_report.html'
reportFileName =  report_dir+fileName
report_url = "https://four.gicdev.com/apitest"
reportUrl = report_url+fileName
with open(reportFileName, 'wb') as f:
      runner = HTMLTestReportCN.HTMLTestRunner(stream=f, title='接口自动化测试报告', description='接口测试用例执行情况', tester='jenkins')
      runner.run(discover)

str=runner.getPassRate()
passRateValue = str.split('%',1)[0]
msgSend(passRateValue,reportUrl)

smtpSer ="smtp.exmail.qq.com"
# 测试服务器群发测试组成员
sendUser ="apitest@demogic.com"
sendPwd ="Api@201906"
recvUser ="test@demogic.com"
#recvUser = "zhangchunyao@demogic.com"

sendResultMail(smtpSer,sendUser,sendPwd,recvUser,reportFileName)



